@echo off

:: Backup-Laufwerke. Wenn fr BD_1 und BD_2 dasselbe Laufwerk
:: angegeben ist, fragt das Skript nicht, auf welchen Laufwerken
:: Backups angelegt werden sollen.
set "BD_1=N"
set "BD_2=E"

:: Name des Backup-Ordners. Kein Laufwerk angeben! Format: Ordner, Ordner\Ordner u. s. w.
set "FPB=Firefox-Profil-Backups"

:: Pfad zum Firefox-Profil
set "FP=E:\Firefox-Profil"

:: Pfad zu Rar.exe
set "rar=C:\Program Files\WinRAR\Rar.exe"

:: ------------------------------------------

tasklist | find /i "firefox.exe">NUL
if not errorlevel 1 (
echo A B B R U C H
echo.
echo Firefox-Profil kann nicht gesichert
echo werden, da Firefox gestartet ist.
echo.
echo Firefox bitte manuell beenden
echo und Batchskript erneut starten.
echo.
echo Drcke eine beliebige Taste.
pause>NUL
goto :eof
)
echo Batch-Skript kann von folgenden im Profil-Ordner
echo enthaltenen Ordnern und Dateien ein Backup anlegen:
echo.
echo Datei  favicons.sqlite
echo Datei  key3.db
echo Datei  key4.db
echo Datei  logins.json
echo Datei  places.sqlite
echo Datei  prefs_.js 
echo Datei  prefs_.js (wird umbenannt in 'prefs.js'.)
echo Datei  user.js
echo Ordner chrome
echo.
echo Mchtest du jetzt ein Backup anlegen?
echo.
if exist "%rar%" goto :next
echo (Batch-Skript kann WinRAR nicht finden.)
echo.
echo Taste [2] Kopieren
echo Taste [3] Abbrechen
echo.
choice /c 23 /n
if errorlevel 2 goto :eof
if errorlevel 1 set "copy=defined"&goto :next2

:next
echo Taste [1] Archivieren (RAR)
echo Taste [2] Kopieren
echo Taste [3] Abbrechen
echo.
choice /c 123 /n
if errorlevel 3 goto :eof
if errorlevel 2 set "copy=defined"

:next2

if "%BD_1%"=="%BD_2%" set "drive_1=%BD_1%"&goto :next3

echo.
echo Auf welchen Laufwerken sollen Backups angelegt werden?
echo.
echo Taste [1] Laufwerk %BD_1%
echo Taste [2] Laufwerk %BD_2%
echo Taste [3] Laufwerk %BD_1% und %BD_2%
echo Taste [4] Abbrechen
echo.
choice /c 1234 /n
if errorlevel 4 goto :eof
if errorlevel 3 set "drive_1=%BD_1%"&set "drive_2=%BD_2%"&goto :next3
if errorlevel 2 set "drive_1=%BD_2%"&goto :next3
if errorlevel 1 set "drive_1=%BD_1%"&goto :next3

:next3

:: Siehe Workshop 'Batch for Runaways - Part III - Datums- und Zeitvariablen im Batch':
:: https://www.administrator.de/wissen/workshop-batch-runaways-part-iii-datums-zeitvariablen-17083.html
if not exist Datum_und_Uhrzeit.vbs echo Wscript.Echo Year(Now)^&" "^&Month(Now)^&" "^&Day(Now)^&" "^&Hour(Now)^&" "^&Minute(Now)^&" "^&Second(Now) > Datum_und_Uhrzeit.vbs
for /f "tokens=1-6" %%a in ('cscript //nologo Datum_und_Uhrzeit.vbs') do (
for %%i in ("YY=%%a" "MM=%%b" "DD=%%c" "hh=%%d" "min=%%e" "ss=%%f") do set %%i
)
del Datum_und_Uhrzeit.vbs
set "dummy=%MM:~1%"&if not defined dummy set "MM=0%MM%"
set "dummy=%DD:~1%"&if not defined dummy set "DD=0%DD%"
set "dummy=%hh:~1%"&if not defined dummy set "hh=0%hh%"
set "dummy=%min:~1%"&if not defined dummy set "min=0%min%"
set "dummy=%ss:~1%"&if not defined dummy set "ss=0%ss%"

set "name=%YY%-%MM%-%DD% @ %hh%.%min%.%ss% (nur wichtigste Dateien)"

if defined copy (
xcopy /H /K "%FP%\favicons.sqlite" "%drive_1%:\%FPB%\%name%\"
xcopy /H /K "%FP%\key3.db" "%drive_1%:\%FPB%\%name%\"
xcopy /H /K "%FP%\key4.db" "%drive_1%:\%FPB%\%name%\"
xcopy /H /K "%FP%\logins.json" "%drive_1%:\%FPB%\%name%\"
xcopy /H /K "%FP%\places.sqlite" "%drive_1%:\%FPB%\%name%\"
echo FD | xcopy /H /K "%FP%\prefs_.js" "%drive_1%:\%FPB%\%name%\prefs.js"
xcopy /H /K "%FP%\prefs_.js" "%drive_1%:\%FPB%\%name%\"
xcopy /H /K "%FP%\user.js" "%drive_1%:\%FPB%\%name%\"
xcopy /E /H /K "%FP%\chrome" "%drive_1%:\%FPB%\%name%\chrome\"
if defined drive_2 xcopy /E /H /K "%drive_1%:\%FPB%\%name%" "%drive_2%:\%FPB%\%name%\"
goto :end
)
:: echo FD: Falls Englisch, greift F fr File, falls Deutsch greift D fr Datei (nach erneuter Eingabeaufforderung).
:: Bei Reihenfolge DF wrde D fr Directory greifen.

if not exist %drive_1%:\%FPB%\ md %drive_1%:\%FPB%

"%rar%" a -m5 -rr7p "%drive_1%:\%FPB%\%name%.rar" "%FP%\favicons.sqlite" "%FP%\key3.db" "%FP%\key4.db" "%FP%\logins.json" "%FP%\places.sqlite" "%FP%\prefs_.js" "%FP%\user.js" "%FP%\chrome"
if exist "%FP%\prefs_.js" (
"%rar%" rn "%drive_1%:\%FPB%\%name%.rar" Firefox-Profil\prefs_.js Firefox-Profil\prefs.js
"%rar%" a -m5 -rr7p -t "%drive_1%:\%FPB%\%name%.rar" "%FP%\prefs_.js"
) else (
"%rar%" t "%drive_1%:\%FPB%\%name%.rar"
)
:: Achtung: -t ist Schalter, t ist Befehl
if defined drive_2 xcopy /H /K "%drive_1%:\%FPB%\%name%.rar" "%drive_2%:\%FPB%\"

:end

echo.
echo Drcke eine beliebige Taste.
pause>NUL